class Metronome
{
	// Class variables prefixed with m for member  ( a common practice )
	float mTempo;			// beats per minute
    dur mSecondsPerBeat; 	// seconds per beat
    int mMeasNum; 			// measure number, zero based
    int mBeatNum;			// beat number, zero based
    int mBeatsPerMeasure; 	// beats per measure
    
    // Class functions follow
    function void init( float tempo, int beatsPerMeasure )
    {
    	// initialize all class variables
    	// tempo => mTempo; // tempo is always beats per minute
    	// calculate duration of one beat (mSecondsPerBeat) at mTempo
    	// set measure number to 0
    	// set beat number to 0
    	// beatsPerMeasure => mBeatsPerMeasure;
    }
        
    // GET SET for mTempo
    function float getTempo()
    {
        return mTempo;
    }
    
    function float setTempo( float tempo )
    {
        tempo => mTempo;
    }

    function void setTempoVariables( float tempo )
    {
        // beatsPerMinute => mTempo
        // also call setBeatDuration to set mSecondsPerBeat
    }
    
    // GET SET for mSecondsPerBeat
    function dur getSecondsPerBeat()
    {
        return mSecondsPerBeat;
    }
    
    function void setSecondsPerBeat()
    {
    	// calculate and set mSecondsPerBeat
    }
    
    // GET mMeasNum
    function int getMeasNum()
    {
        return mMeasNum;
    }
    
    // GET mBeatNum
    function int getBeatNum()
    {
        return mBeatNum;
    }
    
    // SET BOTH mMeasNum and mBeatNum
    function int updateMeasureAndBeatNumbers()
    {
        // beats cycle from zero to mBeatsPerMeasure minus one
        // measures increment when beat cycle resets
    }
    
	// RUN the metronome
    function void doClicks() 
    {
    	// setup click sound and send to dac
    	// add time synchronization formula to sync mSecondsPerBeat
        
        while (true)
        {
        	// include this line for debugging purposes
            <<< getSecondsPerBeat(), getTempo(), getMeasNum(), getBeatNum()  >>>; 
            
            // write the code to produce the clicks 
            // and update mBeatNum and mMeasNum
        }
    } 
} // end class

// These four lines should be all you need to test the code
// Change the parameters to metro.init( tempo, beatsPerMeasure )
// to test different tempos and beats
Metronome metro;
metro.init( 60.0, 4 );
metro.doClicks();
1::minute => now;
